// Lucas Keyes
// Header file for the SpriteImg_ManagerObject, which
// holds all the Sprites for the game, encapsulates and 
// reduces the need for local variables, as well as increases
// program readability

#ifndef __SPRT_IMG_MAN_OBJ__
#define __SPRT_IMG_MAN_OBJ__


#include <ddraw.h>
#include "bsprite.h"
#include "Sbmp.h"
#include "csprite.h"

class SpriteImg_ManagerObject {


private:
	SpriteImg_Object *sprite_array[MAX_SPRITES];
	int size;

public:

	SpriteImg_ManagerObject();
	~SpriteImg_ManagerObject();

	bool create(int index,int frames, int w, int h, 
				bool clipped = false);

	void draw(int index, int frame, int x, int y,
		      LPDIRECTDRAWSURFACE destination);

	BOOL load(int index, SpriteBmp_Object *image,
		      int frame, int x, int y);
	
	void Release(int index);
	void Release_All();

	int frame_count(int index);
	int height(int index);
	int width(int index);

	SpriteImg_Object * getPtr(int index);

	void Restore(int index);
	void Restore_All();

};

#endif