// Lucas Keyes
// Clipped Sprite Image Object source

#include "csprite.h"

ClipSprtImg_Object::ClipSprtImg_Object(int frames, int w, int h)
:SpriteImg_Object(frames,w, h ) {	// constructor for the base

	rectSource.left = 0;
	rectSource.right = w;
	rectSource.top = 0;
	rectSource.bottom = h;

}

void ClipSprtImg_Object::draw(int frame, int x, int y, 
						 LPDIRECTDRAWSURFACE destination) {
	// set up destination rect
	
	RECT rectDest;

	rectDest.left = x;
	rectDest.right = x + s_width;
	rectDest.top = y;
	rectDest.bottom = y + s_height;

	// draw to screen using Blit, which allows clipping as opposed
	// to the regular SpriteImg_Object which doesn't.

	destination->Blt(&rectDest,s_lpDDImage[frame],&rectSource,
						DDBLT_KEYSRC|DDBLT_WAIT,NULL);

}

