// Lucas Keyes
// Super Happy Quad Block defines
#ifndef DEFINES_H
#define DEFINES_H


// defines for windows 
#define WINCLASSNAME "BITMAPTESTCLASS"  // class name

#define WINDOW_WIDTH  800        // size of window
#define WINDOW_HEIGHT 600
#define SCREEN_WIDTH  800         // size of screen
#define SCREEN_HEIGHT 600
#define SCREEN_BPP    8         // bits per pixel

#define BITMAP_ID     0x4D42      // universal id for a bitmap



// Space description Array Constants

#define MAXYCONS 4  // maximum x blocks
#define MAXXCONS 4  // maximum y blocks
#define MAXXPOS 4   // maximum number of positions

// mapGrid constants
#define MAXMAPX 10 // number of columns in mapGrid
#define MAXMAPY 23  // number of rows in mapGrid
#define MINMAPX 0  // beginning column in mapGrid
#define MINMAPY 0  // beginnig row in mapGrid

// input return constants
enum {NOINPUT = 0,LEFT,RIGHT,UP,DOWN,CLOCKWISE,COUNTERCLOCKWISE,
SHUTDOWN,PAUSE};


// collision test constant
#define COLLISION 1

// quadblock descriptor constants
#define QBHEIGHT 20  // height in pixels of a single colored block
#define QBWIDTH 20   // width in pixels of a single colored block

#define NUMBLOCKS 8  // number of different colored blocks

// color description constants
enum {BLACK = 0,BLUE,RED,GREEN,YELLOW,PURPLE,ORANGE,CYAN};

// score and number constants
#define MAXSCOREPOS 9  // maximum number of digits in the score
#define NUMWIDTH 20    // width in pixels of a number
#define NUMHEIGHT 20   // height in pixels of a number
#define MAXNUMS 10     // amount of numbers for one digit (0-9)

// downward moving constants
#define FALLING_ACCELERATION -25
#define START_FALL_CONSTANT 500
#define SPACE_ROTATE_CONSTANT 100

// Ending one's game and ending one's life
#define END_GAME 0
#define END_LIFE 1

#define COLORS 256
#define TRANSPARENT_COLOR 93
#define COLOR_DEPTH 8
#define SWG_WIDTH 192

#define MAX_SOUNDS 64 //maximum number of different sounds
#define MAX_SPRITES 64

#define DS_NUMCHANNELS 8 //number of channels
#define DS_CHANSPERSAMPLE 1 //mono sound
#define DS_BITSPERSAMPLE 8 //8 bit sound
#define DS_SAMPLERATE 22050 //22KHz sampling


// sprite objects enumeration
enum {BLOCKS = 0, NUMARRAY, MENU};

// sound objects enumeration
enum {MUSIC = 0, CRUNCH};

#endif
