// Code for the QuadBlock class

#include "quadblock.h"


QuadBlock::QuadBlock() {
	gridX=gridY=numpos=currentpos = 0;  // sets everything to zero
}


void QuadBlock::createqbA() {

	gridX = 5;
	gridY = 0;
	numpos = 1;
	currentpos = 0;

	// space descriptor settings //
	spaceArray[0].maxX = 0;
	spaceArray[0].maxY = 3;
	spaceArray[0].xmodCW = 2;
	spaceArray[0].ymodCW = -2;
	spaceArray[0].xmodCCW = 2;
	spaceArray[0].ymodCCW = -2;

	//-----------------------------//

	spaceArray[0].array[0][0] = BLUE;
	spaceArray[0].array[1][0] = BLUE;
	spaceArray[0].array[2][0] = BLUE;
	spaceArray[0].array[3][0] = BLUE;

	//-----------------

	spaceArray[1].maxX = 3;
	spaceArray[1].maxY = 0;
	spaceArray[1].xmodCW = -2;
	spaceArray[1].ymodCW = 2;
	spaceArray[1].xmodCCW = -2;
	spaceArray[1].ymodCCW = 2;

	//-----------

	spaceArray[1].array[0][0] = BLUE;
	spaceArray[1].array[0][1] = BLUE;
	spaceArray[1].array[0][2] = BLUE;
	spaceArray[1].array[0][3] = BLUE;

}

void QuadBlock::createqbB() {
	
	gridX = 4;
	gridY = 0;
	numpos = 1;
	currentpos = 0;

	//---------space descriptor ---------//

	spaceArray[0].maxX = 1;
	spaceArray[0].maxY = 2;
	spaceArray[0].xmodCW = 0;
	spaceArray[0].xmodCCW = 0;
	spaceArray[0].ymodCW = 0;
	spaceArray[0].ymodCCW = 0;

	//----------------------

	spaceArray[0].array[0][0] = BLACK;
	spaceArray[0].array[0][1] = RED;
	spaceArray[0].array[1][0] = RED;
	spaceArray[0].array[1][1] = RED;
	spaceArray[0].array[2][0] = RED;
	spaceArray[0].array[2][1] = BLACK;

	//--------------------------------

	spaceArray[1].maxX = 2;
	spaceArray[1].maxY = 1;
	spaceArray[1].xmodCW = 0;
	spaceArray[1].xmodCCW = 0;
	spaceArray[1].ymodCW = 0;
	spaceArray[1].ymodCCW = 0;

	//----------------------------
	spaceArray[1].array[0][0] = RED;
	spaceArray[1].array[0][1] = RED;
	spaceArray[1].array[0][2] = BLACK;
	spaceArray[1].array[1][0] = BLACK;
	spaceArray[1].array[1][1] = RED;
	spaceArray[1].array[1][2] = RED;

}

void QuadBlock::createqbC() {

	gridX = 4;
	gridY = 0;
	numpos = 1;
	currentpos = 0;

	//----------space descriptor array ----------//
	spaceArray[0].maxX = 1;
	spaceArray[0].maxY = 2;
	spaceArray[0].xmodCW = 0;
	spaceArray[0].xmodCCW = 0;
	spaceArray[0].ymodCW = 0;
	spaceArray[0].ymodCCW = 0;

	//------------
	spaceArray[0].array[0][0] = GREEN;
	spaceArray[0].array[0][1] = BLACK;
	spaceArray[0].array[1][0] = GREEN;
	spaceArray[0].array[1][1] = GREEN;
	spaceArray[0].array[2][0] = BLACK;
	spaceArray[0].array[2][1] = GREEN;

	//-------------------------

	spaceArray[1].maxX = 2;
	spaceArray[1].maxY = 1;
	spaceArray[1].xmodCW = 0;
	spaceArray[1].xmodCCW = 0;
	spaceArray[1].ymodCW = 0;
	spaceArray[1].ymodCCW = 0;

	spaceArray[1].array[0][0] = BLACK;
	spaceArray[1].array[0][1] = GREEN;
	spaceArray[1].array[0][2] = GREEN;
	spaceArray[1].array[1][0] = GREEN;
	spaceArray[1].array[1][1] = GREEN;
	spaceArray[1].array[1][2] = BLACK;
}

void QuadBlock::createqbD() {

	gridX = 4;
	gridY = 0;
	numpos = 3;
	currentpos = 0;

	//---------space descriptor --------//

	spaceArray[0].maxX = 2;
	spaceArray[0].maxY = 1;
	spaceArray[0].xmodCW = 0;
	spaceArray[0].ymodCW = 0;
	spaceArray[0].xmodCCW = -1;
	spaceArray[0].ymodCCW = 0;

	//------

	spaceArray[0].array[0][0] = BLACK;
	spaceArray[0].array[0][1] = YELLOW;
	spaceArray[0].array[0][2] = BLACK;
	spaceArray[0].array[1][0] = YELLOW;
	spaceArray[0].array[1][1] = YELLOW;
	spaceArray[0].array[1][2] = YELLOW;

	//--------------

	spaceArray[1].maxX = 1;
	spaceArray[1].maxY = 2;
	spaceArray[1].xmodCW = 1;
	spaceArray[1].ymodCW = 0;
	spaceArray[1].xmodCCW = 1;
	spaceArray[1].ymodCCW = -1;

	//--------------

	spaceArray[1].array[0][0] = YELLOW;
	spaceArray[1].array[0][1] = BLACK;
	spaceArray[1].array[1][0] = YELLOW;
	spaceArray[1].array[1][1] = YELLOW;
	spaceArray[1].array[1][1] = YELLOW;
	spaceArray[1].array[2][0] = YELLOW;
	spaceArray[1].array[2][1] = BLACK;

	//--------------//
	spaceArray[2].maxX = 2;
	spaceArray[2].maxY = 1;
	spaceArray[2].xmodCW = -1;
	spaceArray[2].ymodCW = 1;
	spaceArray[2].xmodCCW = 0;
	spaceArray[2].ymodCCW = 1;

	//--------------

	spaceArray[2].array[0][0] = YELLOW;
	spaceArray[2].array[0][1] = YELLOW;
	spaceArray[2].array[0][2] = YELLOW;
	spaceArray[2].array[1][0] = BLACK;
	spaceArray[2].array[1][1] = YELLOW;
	spaceArray[2].array[1][2] = BLACK;

	//------------------------
	spaceArray[3].maxX = 1;
	spaceArray[3].maxY = 2;
	spaceArray[3].xmodCW = 0;
	spaceArray[3].ymodCW = -1;
	spaceArray[3].xmodCCW = 0;
	spaceArray[3].ymodCCW = 0;

	//-------------

	spaceArray[3].array[0][0] = BLACK;
	spaceArray[3].array[0][1] = YELLOW;
	spaceArray[3].array[1][0] = YELLOW;
	spaceArray[3].array[1][1] = YELLOW;
	spaceArray[3].array[2][0] = BLACK;
	spaceArray[3].array[2][1] = YELLOW;

}

void QuadBlock::createqbE() {

	gridX = 4;
	gridY = 0;
	numpos = 3;
	currentpos = 0;

	//------- space descriptor -----------//
	spaceArray[0].maxX = 1;
	spaceArray[0].maxY = 2;
	spaceArray[0].xmodCW = 0;
	spaceArray[0].ymodCW = -1;
	spaceArray[0].xmodCCW = 0;
	spaceArray[0].ymodCCW = 0;

	//-------

	spaceArray[0].array[0][0] = BLACK;
	spaceArray[0].array[0][1] = PURPLE;
	spaceArray[0].array[1][0] = BLACK;
	spaceArray[0].array[1][1] = PURPLE;
	spaceArray[0].array[2][0] = PURPLE;
	spaceArray[0].array[2][1] = PURPLE;

	// -----

	spaceArray[1].maxX = 2;
	spaceArray[1].maxY = 1;
	spaceArray[1].xmodCW = 0;
	spaceArray[1].ymodCW = 0;
	spaceArray[1].xmodCCW = -1;
	spaceArray[1].ymodCCW = 0;

	//-------

	spaceArray[1].array[0][0] = PURPLE;
	spaceArray[1].array[0][1] = BLACK;
	spaceArray[1].array[0][2] = BLACK;
	spaceArray[1].array[1][0] = PURPLE;
	spaceArray[1].array[1][1] = PURPLE;
	spaceArray[1].array[1][2] = PURPLE;

	//--------

	spaceArray[2].maxX = 1;
	spaceArray[2].maxY = 2;
	spaceArray[2].xmodCW = 1;
	spaceArray[2].ymodCW = 0;
	spaceArray[2].xmodCCW = 1;
	spaceArray[2].ymodCCW = -1;

	//-------

	spaceArray[2].array[0][0] = PURPLE;
	spaceArray[2].array[0][1] = PURPLE;
	spaceArray[2].array[1][0] = PURPLE;
	spaceArray[2].array[1][1] = BLACK;
	spaceArray[2].array[2][0] = PURPLE;
	spaceArray[2].array[2][1] = BLACK;

	//-------

	spaceArray[3].maxX = 2;
	spaceArray[3].maxY = 1;
	spaceArray[3].xmodCW = -1;
	spaceArray[3].ymodCW = 1;
	spaceArray[3].xmodCCW = 0;
	spaceArray[3].ymodCCW = 1;

	//---------

	spaceArray[3].array[0][0] = PURPLE;
	spaceArray[3].array[0][1] = PURPLE;
	spaceArray[3].array[0][2] = PURPLE;
	spaceArray[3].array[1][0] = BLACK;
	spaceArray[3].array[1][1] = BLACK;
	spaceArray[3].array[1][2] = PURPLE;

}

void QuadBlock::createqbF() {

	gridX = 5;
	gridY = 0;
	numpos = 3;
	currentpos = 0;

	//------------ space descriptor ------//
	spaceArray[0].maxX = 1;
	spaceArray[0].maxY = 2;
	spaceArray[0].xmodCW = 1;
	spaceArray[0].ymodCW = 0;
	spaceArray[0].xmodCCW = 1;
	spaceArray[0].ymodCCW = -1;

	//------

	spaceArray[0].array[0][0] = ORANGE;
	spaceArray[0].array[0][1] = BLACK;
	spaceArray[0].array[1][0] = ORANGE;
	spaceArray[0].array[1][1] = BLACK;
	spaceArray[0].array[2][0] = ORANGE;
	spaceArray[0].array[2][1] = ORANGE;

	//--------

	spaceArray[1].maxX = 2;
	spaceArray[1].maxY = 1;
	spaceArray[1].xmodCW = -1;
	spaceArray[1].ymodCW = 1;
	spaceArray[1].xmodCCW = 0;
	spaceArray[1].ymodCCW = 0;

	//---------

	spaceArray[1].array[0][0] = ORANGE;
	spaceArray[1].array[0][1] = ORANGE;
	spaceArray[1].array[0][2] = ORANGE;
	spaceArray[1].array[1][0] = ORANGE;
	spaceArray[1].array[1][1] = BLACK;
	spaceArray[1].array[1][2] = BLACK;

	//---------

	spaceArray[2].maxX = 1;
	spaceArray[2].maxY = 2;
	spaceArray[2].xmodCW = 0;
	spaceArray[2].ymodCW = -1;
	spaceArray[2].xmodCCW = 0;
	spaceArray[2].ymodCCW = 0;

	//------
	spaceArray[2].array[0][0] = ORANGE;
	spaceArray[2].array[0][1] = ORANGE;
	spaceArray[2].array[1][0] = BLACK;
	spaceArray[2].array[1][1] = ORANGE;
	spaceArray[2].array[2][0] = BLACK;
	spaceArray[2].array[2][1] = ORANGE;

	//---------

	spaceArray[3].maxX = 2;
	spaceArray[3].maxY = 1;
	spaceArray[3].xmodCW = 0;
	spaceArray[3].ymodCW = 0;
	spaceArray[3].xmodCCW = -1;
	spaceArray[3].ymodCCW = 0;

	//---------

	spaceArray[3].array[0][0] = BLACK;
	spaceArray[3].array[0][1] = BLACK;
	spaceArray[3].array[0][2] = ORANGE;
	spaceArray[3].array[1][0] = ORANGE;
	spaceArray[3].array[1][1] = ORANGE;
	spaceArray[3].array[1][2] = ORANGE;

}

void QuadBlock::createqbG() {

	gridX = 5;
	gridY = 0;
	numpos = 0;
	currentpos = 0;

	//------ space descriptor array ------//
	spaceArray[0].maxX = 1;
	spaceArray[0].maxY = 1;
	spaceArray[0].xmodCW = 0;
	spaceArray[0].ymodCW = 0;
	spaceArray[0].xmodCCW = 0;
	spaceArray[0].ymodCCW = 0;

	//------

	spaceArray[0].array[0][0] = CYAN;
	spaceArray[0].array[0][1] = CYAN;
	spaceArray[0].array[1][0] = CYAN;
	spaceArray[0].array[1][1] = CYAN;

}



//------------------------------------------------------------------------------

void QuadBlock::copyQuadBlocks(QuadBlock copyfrom) {

	gridX = copyfrom.gridX;
	gridY = copyfrom.gridY;

	currentpos = copyfrom.currentpos;
	numpos = copyfrom.numpos;

	for (int pos = 0; pos <= numpos; pos++) {
		spaceArray[pos].maxX = copyfrom.spaceArray[pos].maxX;
		spaceArray[pos].maxY = copyfrom.spaceArray[pos].maxY;
		spaceArray[pos].xmodCCW = copyfrom.spaceArray[pos].xmodCCW;
		spaceArray[pos].xmodCW = copyfrom.spaceArray[pos].xmodCW;
		spaceArray[pos].ymodCCW = copyfrom.spaceArray[pos].ymodCCW;
		spaceArray[pos].ymodCW = copyfrom.spaceArray[pos].ymodCW;

		for (int y = 0; y <= spaceArray[pos].maxY;y++)
			for (int x = 0; x <= spaceArray[pos].maxX; x++)
				spaceArray[pos].array[y][x] = copyfrom.spaceArray[pos].array[y][x];
	}

}

void QuadBlock::setnewXYPosition(int movement) {
		// this lower level function changes the gridX and gridY of the QuadBlock
	// based on the movement specified in the parameters.  Also, if the movement
	// is a rotation, it shifts the spacedesc array either forward(CLOCKWISE) or
	// backwards (COUNTERCLOCKWISE)
  
	switch( movement) {
	case LEFT: 
		gridX--;		// move left
		break;
	case RIGHT:
		gridX++;		// move right
		break;    
	case DOWN:
	 	gridY++;		// move down
		break;
	case UP:
		gridY--;		// move up
		break;
	case CLOCKWISE:
		if (currentpos < numpos)				// increment the current position
			currentpos = currentpos+1;
		else 
			currentpos = 0;  

		gridX = gridX + spaceArray[currentpos].xmodCW;	// modify the x-value 
		gridY = gridY + spaceArray[currentpos].ymodCW;	// modify the y-va lue
		break;
	case COUNTERCLOCKWISE:
		if (currentpos > 0)						// decrement the current position
	 		currentpos = currentpos - 1;
		else 
			currentpos = numpos;
	
		gridX = gridX + spaceArray[currentpos].xmodCCW;	// modify the x-value
		gridY = gridY + spaceArray[currentpos].ymodCCW;	// modify the y-value
		break;
	}


}


int QuadBlock::currentColorAt(int x, int y) {

	return spaceArray[currentpos].array[y][x];

}

bool QuadBlock::inBounds() {

	// this functionn tests to make sure that the QuadBlock is between the 
	// boundaries set for the mapGrid.

	if (gridX < MINMAPX)		// if beyond left boundary
		return false;
	else if (gridX+spaceArray[currentpos].maxX > MAXMAPX-1)  // if beyond right boundary
		return false;
		else if (gridY < MINMAPY)	// if beyond top boundary
			return false;
			else if (gridY + spaceArray[currentpos].maxY > MAXMAPY-1) // if beyond bottom boundary
				return false;
				else 
					return true;

}