// Lucas Keyes
// Sound Manager object, contains and controls all sounds for 
// a game.

#ifndef __SND_MAN_OBJ__
#define __SND_MAN_OBJ__

#include <dsound.h>

#include "defines.h"
#include "soundobject.h"

class Sound_ManagerObject {

private:
	SoundObject *sound_array[MAX_SOUNDS];
	int size;

public:
	Sound_ManagerObject();
	~Sound_ManagerObject();

	void clear(int index);
	void clearAll();

	bool load(int index, char *filename, int copies = 1);

	void pause(int index);
	void pauseAll();

	void play(int index, bool looping = false);

	void stop(int index);
	void stopAll();

};

#endif